/*
Copyright 2020 The Knative Authors

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by informer-gen. DO NOT EDIT.

package v1alpha1

import (
	time "time"

	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	runtime "k8s.io/apimachinery/pkg/runtime"
	watch "k8s.io/apimachinery/pkg/watch"
	cache "k8s.io/client-go/tools/cache"
	legacysourcesv1alpha1 "knative.dev/eventing/pkg/apis/legacysources/v1alpha1"
	versioned "knative.dev/eventing/pkg/legacyclient/clientset/versioned"
	internalinterfaces "knative.dev/eventing/pkg/legacyclient/informers/externalversions/internalinterfaces"
	v1alpha1 "knative.dev/eventing/pkg/legacyclient/listers/legacysources/v1alpha1"
)

// ContainerSourceInformer provides access to a shared informer and lister for
// ContainerSources.
type ContainerSourceInformer interface {
	Informer() cache.SharedIndexInformer
	Lister() v1alpha1.ContainerSourceLister
}

type containerSourceInformer struct {
	factory          internalinterfaces.SharedInformerFactory
	tweakListOptions internalinterfaces.TweakListOptionsFunc
	namespace        string
}

// NewContainerSourceInformer constructs a new informer for ContainerSource type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewContainerSourceInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers) cache.SharedIndexInformer {
	return NewFilteredContainerSourceInformer(client, namespace, resyncPeriod, indexers, nil)
}

// NewFilteredContainerSourceInformer constructs a new informer for ContainerSource type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewFilteredContainerSourceInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers, tweakListOptions internalinterfaces.TweakListOptionsFunc) cache.SharedIndexInformer {
	return cache.NewSharedIndexInformer(
		&cache.ListWatch{
			ListFunc: func(options v1.ListOptions) (runtime.Object, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.SourcesV1alpha1().ContainerSources(namespace).List(options)
			},
			WatchFunc: func(options v1.ListOptions) (watch.Interface, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.SourcesV1alpha1().ContainerSources(namespace).Watch(options)
			},
		},
		&legacysourcesv1alpha1.ContainerSource{},
		resyncPeriod,
		indexers,
	)
}

func (f *containerSourceInformer) defaultInformer(client versioned.Interface, resyncPeriod time.Duration) cache.SharedIndexInformer {
	return NewFilteredContainerSourceInformer(client, f.namespace, resyncPeriod, cache.Indexers{cache.NamespaceIndex: cache.MetaNamespaceIndexFunc}, f.tweakListOptions)
}

func (f *containerSourceInformer) Informer() cache.SharedIndexInformer {
	return f.factory.InformerFor(&legacysourcesv1alpha1.ContainerSource{}, f.defaultInformer)
}

func (f *containerSourceInformer) Lister() v1alpha1.ContainerSourceLister {
	return v1alpha1.NewContainerSourceLister(f.Informer().GetIndexer())
}
